Undirector< DGR > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Classes | Public Types | Public Member Functions | Static Public Member Functions | Related Functions
Undirector< DGR > Class Template Reference
Adaptor Classes for Graphs

## Detailed Description

### template<typename DGR>
class lemon::Undirector< DGR >

Undirector adaptor can be used for viewing a digraph as an undirected graph. All arcs of the underlying digraph are showed in the adaptor as an edge (and also as a pair of arcs, of course). This adaptor conforms to the Graph concept.

The adapted digraph can also be modified through this adaptor by adding or removing nodes or edges, unless the `GR` template parameter is set to be `const`.

This class provides item counting in the same time as the adapted digraph structure.

Template Parameters

  DGR | The type of the adapted digraph. It must conform to the Digraph concept. It can also be specified to be `const`.

Note
  The `Node` type of this adaptor and the adapted digraph are convertible to each other, moreover the `Edge` type of the adaptor and the `Arc` type of the adapted digraph are also convertible to each other. (Thus the `Arc` type of the adaptor is convertible to the `Arc` type of the adapted digraph.)

`#include <lemon/adaptors.h>`

## Classes
class | CombinedArcMap
| Arc map combined from two original arc maps. More...

## Public Types
typedef DGR | Digraph
| The type of the adapted digraph.

## Public Member Functions
| Undirector (DGR &digraph)
| Constructor. More...

## Static Public Member Functions
template<typename FW , typename BK >
static CombinedArcMap< FW, BK > | combinedArcMap (FW &forward, BK &backward)
| Returns a combined arc map. More...

## Related Functions
(Note that these are not member functions.)
template<typename DGR >
Undirector< const DGR > | undirector (const DGR &digraph)
| Returns a read-only Undirector adaptor. More...

## Constructor & Destructor Documentation

Undirector | ( | DGR & | digraph | ) |
| inline

Creates an undirected graph from the given digraph.

## Member Function Documentation

static CombinedArcMap<FW, BK> combinedArcMap | ( | FW & | forward,
|  | BK & | backward
| ) |  |
| inlinestatic

This function just returns a combined arc map.